Installation
============

Debian/Ubuntu
-------------

    apt-get install git-core tinc


Archlinux
---------

    pacman -S git tinc

MacOS X
-------

    ruby -e "$(curl -fsSL https://raw.github.com/mxcl/homebrew/go)"
    brew install tuntap # WICHTIG: Befehle, welche das Programm am Ende
                        # ausspuckt befolgen und Rechner neustarten
    brew install tinc

Konfiguration
-------------

SSH-Schlüssel uns geben oder erstellen, wenn keiner vorhanden ist

    cat ~/.ssh/id_rsa.pub || ssh-keygen -t rsa -b 4096 && cat ~/.ssh/id_rsa.pub

Wenn der Schlüssel eingetragen im git eingetragen ist, die Konfiguration clonen:

    cd /etc/tinc
    mkdir closedvpn
    sudo chown -R $USER closedvpn
    git clone git@higgsboson.tk:closedvpn-hosts closedvpn

Konfiguration anpassen

    cd /etc/tinc/closedvpn # /usr/local/etc/tinc on MacOS X
    cp tinc.conf-template tinc.conf

in `tinc.conf` `<DEIN NAME>` durch wiedererkennbaren Server/Rechnernamen
ersetzen (Nur Buchstaben, keine Bindestriche)

    cp tinc-up-template tinc-up

im Ordner `hosts` eine Datei mit dem gleichen Namen anlegen. `<DEINE IP>` durch
die von uns festgelegte Adresse ersetzen

    cp hosts-template hosts/<DEIN NAME>

in `tinc-up` `<DEINE IP>` durch eine von uns festgelegte IP ersetzen

    cp tinc-up-template tinc-up

Schlüssel erzeugen

    tincd -n closedvpn -K

Dies erzeugt einen Private-Key in `/etc/tinc/closedvpn/rsa_key.priv` und fügt
den Public Key an die Datei hosts/`<DEIN NAME>` an. Die Host-Datei zu git
hinzufügen:

    git add hosts/<DEIN NAME>
    git commit -m "Add host <DEIN NAME>"

Wenn wir den Schlüssel hinzugefügt haben, kannst du das vpn zum Testen mit
folgenden Befehl starten:

    tincd -c /etc/tinc/closedvpn -D

Durch drücken von Strg+C wird die Logausgabe erhöht. Strg+\ beendet das
Programm.

Wenn alles funktioniert kannst du die Adresse 10.42.16.1 erreichbar sein

    ping 10.42.16.1

Auflösen von Adressen mittels Searchdomains:
--------------------------------------------

Auf dem Mac erst folgende Anleitung durchgehen um DNS Search Domains zu fixen:
  http://www.eigenspace.org/2011/07/fixing-osx-lion-dns-search-domains/

Danach -> Netzwerkeinstellungen - Suchdomain -> vpn.higgsboson.tk

Auf Linux:

$ cp /etc/tinc/closedvpn/resolvconf.conf /etc/resolvconf.conf

Alternative: Auflösen von Adressen via dnsmasq:
-----------------------------------------

    $ cp /etc/tinc/closedvpn/resolvconf.conf.dnsmasq /etc/resolvconf.conf
    $ cp /etc/tinc/closedvpn/dnsmasq.conf /etc/dnsmasq.conf

    $ apt-get install dnsmasq

oder

    $ pacman -S dnsmasq
